package ru.sicamp.sicamphelper.api.controller

import mu.KLogging
import org.springframework.web.bind.annotation.*
import ru.sicamp.sicamphelper.model.dto.UserDto
import ru.sicamp.sicamphelper.model.info.UserInfo
import ru.sicamp.sicamphelper.service.UserService

@RestController
class UsersController(
    private val userService: UserService,
) {
    @PostMapping("/user/create")
    fun create(@RequestParam dto: UserDto): UserInfo {
        return userService.createUser(dto)
    }

    @GetMapping("/user/find/{login}")
    fun getUser(@PathVariable(name = "login", required = true) login: String): UserInfo {
        logger.info("Getting user with username: $login")
        return userService.findUserInfoByLogin(login)
    }

    companion object : KLogging()
}