package ru.sicamp.sicamphelper.security

import org.springframework.security.core.userdetails.UserDetailsService
import org.springframework.stereotype.Service
import ru.sicamp.sicamphelper.db.entity.User
import ru.sicamp.sicamphelper.repository.UserRepository
import ru.sicamp.sicamphelper.util.badArgument

@Service
class UserDetailsServiceImpl(
    private val userRepository: UserRepository
) : UserDetailsService {
    override fun loadUserByUsername(username: String?): User = userRepository.findUserByUsername(
        username = username ?: badArgument("Username shouldn't be null")
    )
}
